#ifndef __VZCTL_LIC_H__
#define __VZCTL_LIC_H__

#include <linux/types.h>
#include <linux/ioctl.h>

#define VZLICTYPE ']'
#define VZLIC_NOTIFY		_IO(VZLICTYPE, 0)
#define VZLIC_START		_IO(VZLICTYPE, 1)

#define VZLIC_START_SIGN	_IO(VZLICTYPE, 2)
#define VZLIC_NOTIFY_SIGN	_IO(VZLICTYPE, 3)

/* code.flags */
#define VZLIC_FLAG_NO_OOM	0x0001	/* disable oom killer */
#define VZLIC_FLAG_NO_CORE	0x0002	/* disable core dumps */
#define VZLIC_FLAG_NO_TRACE	0x0008	/* disable ptrace */
#define VZLIC_FLAG_NO_THREADS	0x0010	/* forbid threads */
#define VZLIC_FLAG_NO_RETCHECK	0x0020	/* don't check return address */
#define VZLIC_FLAG_MMAP_READ	0x0100	/* mmap license for read-only */
#define VZLIC_FLAG_MMAP_WRITE	0x0200	/* mmap license for read-write */
#define VZLIC_FLAG_CAN_NOTIFY	0x1000	/* can call VZLIC_NOTIFY_SIGN */

/* lic.status */
#define VZLIC_STATUS_DEVEL	0x0001	/* developer key were used */

#define MAX_SIG_SIZE    48

#define VZLIC_SHM_SIZE	(4096*3)

struct vzlic_sign {
	struct {
		unsigned int version;
		unsigned int flags;
		unsigned long long start;
		unsigned long long size;
		unsigned char signature[MAX_SIG_SIZE];
	} code;
	unsigned char signature[MAX_SIG_SIZE];	/* signature for .code */
	struct {
		unsigned long long start;
		unsigned int size;
		unsigned int status;
	} lic; /* non-signed output block */
};

#endif
