/*
 *  include/linux/vzlink.h
 *
 *  Copyright (C) 2006  SWsoft
 *  All rights reserved.
 *  
 *  Licensing governed by "linux/COPYING.SWsoft" file.
 *
 */

#ifndef __VZLINK_H__
#define __VZLINK_H__

#include <linux/types.h>
#include <linux/ioctl.h>

#ifndef __ENVID_T_DEFINED__
typedef unsigned envid_t;
#define __ENVID_T_DEFINED__
#endif

#define VZLINK_MAJOR 125
#define VZLINK_NAME  "vzlink"


struct vzlink_send {
	__u32	id;
	envid_t	veid;	 /* destination */
	__u32	timeout; /* milliseconds */

	int	pipe[2];
	char	__reserved[32];	/* should be set to 0! */
};

struct vzlink_receive {
	__u32	timeout; /* milliseconds */

	pid_t	pid;    /* Sender credentials */
	pid_t	ugid;
	pid_t	euid;
	envid_t	veid;
	__u32	id;

	int	pipe[2];
	char	__reserved[32]; /* will be filled by 0! */
};

#define VZLINKCTL '`'

#define VZLINKCTL_SEND		_IOW(VZLINKCTL, 3, struct vzlink_send)
#define VZLINKCTL_RECEIVE	_IOWR(VZLINKCTL, 4, struct vzlink_receive)

#endif
