%define _unpackaged_files_terminate_build 0%{nil}
%define __os_install_post /usr/lib/rpm/brp-compress %{nil}
%define current_version 7.0.9
%define osrelease	3.16.6

%define vzpkgenv_path	vz/pkgenv
%define __find_provides %{nil}
%define __os_install_post %{nil}
%define environment	vzpkgenvzypp49
%ifarch x86_64
%define technologies    "x86_64 nptl"
%define pkgman_path     %{vzpkgenv_path}/rpmzypp49x64
%else
%define technologies    "x86 nptl"
%define pkgman_path     %{vzpkgenv_path}/rpmzypp49x86
%endif

#  RPM's list macro for build section
# SourceXYZ: list
%define source_list() %((s=1;cd %_sourcedir; for rpm in $(ls *.rpm);do echo Source$s:"${rpm%}";s=$(($s+1)); done))

Summary: Chroot environment for rpm-4.11.3
Name:	vzpkgenvzypp49x64
Version: %{current_version}
Release: 14%{?dist}
Group: System Environment/Base
License: GPL
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: fakeroot
ExclusiveArch:	x86_64
AutoReq: 0
AutoProv: 0

Source0:	passwd
# how to extract this list:
# run minimal chroot via zypper in
# or openvz or docker
# rpm -qa > /tmp/list
# sed -i 's!x86_64!x86_64.rpm' /tmp/list
# sed -i 's!noarch!noarch.rpm' /tmp/list
%source_list

%description
Chroot environment for execution Virtuozzo version of yum package

%prep

rm -rf $RPM_BUILD_DIR/%{environment}
%setup -q -Tc -n %{name}

%build

%define debug_package %{nil}

function parse_find() {
    while read rattr fname; do
	echo $fname >> files.lst
	if [ "${fname%*.pyc}" != "${fname}" ]; then
	    echo %ghost ${fname/.\///%{pkgman_path}/} >> files.2lst
	else
	    echo $rattr ${fname/.\///%{pkgman_path}/} >> files.2lst
	fi
    done
}

for i in files.lst files.2lst; do
    rm -f $i || /bin/true
    touch $i
done

DIR=$RPM_BUILD_DIR/%{name}/%{environment}

mkdir -p $DIR/var/lock/rpm
mkdir -p $DIR/var/lib/rpm
mkdir -p $DIR/var/tmp
mkdir -p $DIR/dev
rpm --initdb --root $DIR >/dev/null 2>&1

for package in %{sources}
do
%ifarch x86_64
  if grep -q -E '\.x86_64\.rpm|\.noarch.rpm' <<< $package
%else
  if grep -q -E '\.i686\.rpm|\.noarch.rpm' <<< $package
%endif
  then
    fakeroot rpm2cpio $package | fakeroot cpio -idv || true
  fi
done

cp ./bin/rpm ./usr/lib/rpm
ln -s ./rpm ./usr/lib/rpm/rpmq
ln -s ./rpm ./usr/lib/rpm/rpmi
cp $RPM_SOURCE_DIR/passwd ./etc

rm -rf ./var/lib/rpm/*
/bin/rpm --initdb --root=$DIR
rm -f ./var/lib/rpm/__db*
rm -f ./var/lib/rpm/.rpm.lock
# move rpm data from %build/vzpkgenvzypp49
# to the current dir
mv $DIR/var/lib/rpm/* ./var/lib/rpm/

find ./bin -name rpm -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./bin -name bash -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./bin -name sh -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./bin -name mkdir -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc/rpm -name platform -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib/rpm/ -type f  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib/rpm/ -type l  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find . -name \*.so -printf '%%%attr(%m,root,root) %p\n' | parse_find
find . -name \*.so.* -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./var/lib/rpm -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name zypper -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./bin -name gzip -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name gzip -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name bzip2 -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name lzma -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name xz -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name uuidgen -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name deltainfoxml2solv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name dumpsolv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name installcheck -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name mergesolv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name repo2solv.sh -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name repomdxml2solv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name rpmdb2solv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name rpmmd2solv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name rpms2solv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name susetags2solv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name updateinfoxml2solv -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name rpmdb -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name rpmkeys -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name gpg -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name gpg2 -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib/zypp -printf '%%%attr(%m,root,root) %p\n' | parse_find

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{pkgman_path}

tar --files-from=files.lst -cf - | tar --directory %buildroot/%{pkgman_path} -xf - 

echo "%technologies" > %{buildroot}/%{pkgman_path}/technologies
echo "%osrelease" > %{buildroot}/%{pkgman_path}/osrelease
echo "%attr(644,root,root) /%{pkgman_path}/technologies" >> files.2lst
echo "%attr(644,root,root) /%{pkgman_path}/osrelease" >> files.2lst

for i in `find %{buildroot} -type d | sed "s,^%{buildroot},,g"`; do
	if [ $i != "/vz" ] && [ $i != "/vz/pkgenv" ]; then
		echo "%attr(0755, root, root) %dir $i" >> files.2lst
	fi
done

%clean
rm -rf $RPM_BUILD_DIR/%{environment}

%postun
if [ $1 -eq 0 ]; then
	rm -rf /%{pkgman_path} >/dev/null 2>&1
fi

%files -f files.2lst

%changelog
* Fri Sep  9 2016 Konstantin Volkov <wolf@virtuozzo.com> 7.0.9-14
- Make setns to Container before unpack rpms, see #PSBM-50243

* Mon Jun 13 2016 Alexander Stefanov astefanov@virtuozzo.com> 7.0.9-13
- invoke run_from_chroot binary from /usr/libexec instead of /usr/share/libvznbdmig, #PSBM-48232
- bump libsolv-tools release

* Wed Jun 08 2016 Konstantin Volkov <wolf@virtuozzo.com> 7.0.9-12
 - Technical rebuild, see #PSBM-47948

* Fri May 13 2016 Alexander Stefanov-Khryukin <akhryukin@virtuozzo.com> 7.0.9-10
- fix #PSBM-47099

* Fri May 6 2016 Alexander Stefanov-Khryukin <akhryukin@virtuozzo.com> 7.0.9-10
- Include RPM data into the bootstrap package
- remove redundant whitespaces
- increase release to 10

* Thu Apr 28 2016 Konstantin Volkov <wolf@virtuozzo.com> 7.0.9-9
- Small fix for %environment, see #PSBM-45333

* Wed Apr 27 2016 Alexander Stefanov-Khryukin <akhryukin@virtuozzo.com> 7.0.9-1
- spec rewritten
- zypper improved for modern openvz see #PSBM-45333
- remove excessive data from /usr/share/

* Wed Dec 25 2013 Konstantin Volckov <wolf@parallels.com> 6.1.0-7
- Preload resolv libraries from chroot, see #PCLIN-32277

* Sat Dec 21 2013 Konstantin Volckov <wolf@parallels.com> 6.1.0-6
- Rebase to OpenSuSE 13.1, see #PCLIN-32247

* Tue Oct 01 2013 Konstantin Volckov <wolf@parallels.com> 6.1.0-5
- Ignore different csums in susedata and primary xmls, see #PCLIN-32096

* Sat Feb 16 2012 Konstantin Volckov <wolf@parallels.com> 6.1.0-4
- Call gpg from chroot, see #PSBM-18219

* Thu Jan 12 2012 Konstantin Volckov <wolf@parallels.com> 5.0.0-3
- Fixed vz_template descriptor initialization, see #PCLIN-30619

* Tue Dec 20 2011 Konstantin Volckov <wolf@parallels.com> 5.0.0-2
- Fixed epoch in outfile, see #PCLIN-30552

* Fri Dec 09 2011 Konstantin Volckov <wolf@parallels.com> 5.0.0-1
- Changed version to 5.0.0
- Added rpmkeys and rpmdb binaries
- Improved build systemd: remove std template Makefiles, see #PSBM-10433

* Tue Dec 06 2011 Konstantin Volckov <wolf@parallels.com> 4.7.0-1
- Initial version of vzpkgenvzypp49 environment, see #PSBM-10071
